 Unit redaktor;


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Menus, ComCtrls;

type
   TShape=(sPen, sRect, sEllipse,sPoly, sFill);
  TPAINT = class(TForm)
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    karandaw: TSpeedButton;
    prygol: TSpeedButton;
    ellipse: TSpeedButton;
    mnogygol: TSpeedButton;
    zalivka: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    PaintBox1: TPaintBox;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N4: TMenuItem;
    N2: TMenuItem;
    Edit_Canvas_name: TEdit;
    Label3: TLabel;
    N5: TMenuItem;
    cbb1: TComboBox;
    cbb2: TComboBox;
    lbl1: TLabel;
    lbl2: TLabel;
    lbl3: TLabel;
    edt1: TEdit;
    ud1: TUpDown;
    Button1: TButton;
    Timer1: TTimer;
    ColorDialog1: TColorDialog;
    line_color: TImage;
    fill_color: TImage;
    procedure fill_colorClick(Sender: TObject);
    procedure line_colorClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ud1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
    procedure cbb2Change(Sender: TObject);
    procedure cbb1Change(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure N4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PAINT: TPAINT;
  img: TBitmap;
  buf: TBitmap;
  x0, y0: integer;
  dwn: boolean;
  nowdrawing:TShape;


implementation

uses Unit1;

{$R *.dfm}



procedure TPAINT.Button1Click(Sender: TObject);
begin
form1.show;
end;

procedure TPAINT.cbb1Change(Sender: TObject);
begin
case cbb1.ItemIndex of
0 : img.Canvas.Pen.Style:=psSolid;
1 : img.Canvas.Pen.Style:=psDash;
2 : img.Canvas.Pen.Style:=psDot;
3 : img.Canvas.Pen.Style:=psDashDot;
4 : img.Canvas.Pen.Style:=psDashDotDot;
5 : img.Canvas.Pen.Style:=psClear;
end;
form1.memo1.Lines.Add(edit_canvas_name.text+'.Pen.Style:='+cbb1.Items[cbb1.itemindex]+';');
end;

procedure TPAINT.cbb2Change(Sender: TObject);
begin
case cbb2.ItemIndex of
0 : img.Canvas.Brush.Style:=bsSolid;
1 : img.Canvas.Brush.Style:=bsHorizontal;
2 : img.Canvas.Brush.Style:=bsVertical;
3 : img.Canvas.Brush.Style:=bsFDiagonal;
4 : img.Canvas.Brush.Style:=bsBDiagonal;
5 : img.Canvas.Brush.Style:=bsClear;
end;


form1.memo1.Lines.Add(edit_canvas_name.text+'.Brush.Style:='+cbb2.Items[cbb2.itemindex]+';');
end;

procedure TPAINT.fill_colorClick(Sender: TObject);
begin
if colordialog1.Execute then
begin
  form1.memo1.Lines.Add(edit_canvas_name.text+'.brush.Color:=rgb('+inttostr(getrvalue(colordialog1.Color))
     +','+inttostr(getgvalue(colordialog1.Color))+','+inttostr(getbvalue(colordialog1.Color))+');');
  fill_color.Canvas.Brush.Color:=colordialog1.Color;
  fill_color.Canvas.Rectangle(1,1,19,19);
end;
end;

procedure TPAINT.FormCreate(Sender: TObject);

begin
  Img:=TBitmap.Create;
  buf:=TBitmap.Create;
  img.Width:=PaintBox1.ClientWidth;
  buf.width:=PaintBox1.ClientWidth;
  img.Height:=PaintBox1.ClientHeight;
  buf.Height:=PaintBox1.ClientHeight;
  nowdrawing:=sPen;
  dwn:=false;

  cbb1.itemindex:=0;
  cbb2.itemindex:=0;
  ud1.Position:=1;

  fill_color.Canvas.Brush.Color:=clWhite;
  fill_color.Canvas.Rectangle(1,1,19,19);

  line_color.Canvas.Brush.Color:=clBlack;
  line_color.Canvas.Rectangle(1,1,19,19);

end;

procedure TPAINT.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if button=mbLeft then
  begin
   img.assign(buf);
   x0:=x; y0:=y;
  if karandaw.Down then    // 
   begin
    nowdrawing:=sPen;
    img.canvas.MoveTo(x,y);
    form1.memo1.Lines.Add(edit_canvas_name.text+'.MoveTo('+inttostr(x)+','+inttostr(y)+');');
  end else
   if prygol.Down then   // 
    nowdrawing:=sRect else
   if ellipse.Down then    // 
    nowdrawing:=sEllipse else
   if mnogygol.Down then     // 
    nowdrawing:=sPoly else
   if zalivka.Down then     //
    nowdrawing:=sFill;
  dwn:=true;
  img.Canvas.Pen.Color:=line_color.Canvas.Pixels[10,10];
  if cbb2.ItemIndex<>5 then img.Canvas.Brush.Color:=fill_color.Canvas.Pixels[10,10];

    if nowdrawing=sFill then
     begin
  img.Canvas.FloodFill(x0,y0,img.Canvas.Pixels[x,y],fsSurface);
   form1.memo1.Lines.Add(edit_canvas_name.text+'.FloodFill('+inttostr(x0)+','+inttostr(y0)+','
       +edit_canvas_name.text+'.Pixels['+inttostr(x)+','+inttostr(y)+'],fsSurface);');
  buf.Assign(img);
  dwn:=false;
  end
  end else
  begin
   if (dwn) and (nowdrawing=sPoly) then
   begin
   x0:=x;
   y0:=y;
   buf.Assign(img);
  end;
end;
  paintbox1.Canvas.CopyRect(bounds(0,0,img.Width,img.Height), img.Canvas, bounds(0,0,img.Width, img.Height));
  end;

procedure TPAINT.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if not dwn then exit;
  img.Assign(buf);
 case nowdrawing of
    sPen:begin
      img.Canvas.LineTo(x,y);
      form1.memo1.Lines.Add(edit_canvas_name.Text+'.LineTo('+inttostr(x)+','+inttostr(y)+');');
      buf.Assign(img);
         end;
    sRect:begin
      img.Canvas.Rectangle(x0,y0,x,y);
          end;
    sEllipse:begin
      img.Canvas.Ellipse(x0,y0,x,y);
             end;
    sPoly:begin
      img.Canvas.MoveTo(x0,y0);
      img.Canvas.LineTo(x,y);
          end;
    sFill:begin
    //nothing.
    end;
    end;
    paintbox1.Canvas.CopyRect(bounds(0,0,img.Width,img.Height), img.Canvas, bounds(0,0, img.Width, img.Height));

end;

procedure TPAINT.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button=mbLeft then dwn:=false;
buf.Assign(img);

 case nowdrawing of
     sRect:begin
      img.Canvas.Rectangle(x0,y0,x,y);
      form1.memo1.Lines.Add(edit_canvas_name.Text+'.Rectangle('+inttostr(x0)+','+inttostr(y0)+','+inttostr(x)+','+inttostr(y)+');');
          end;
    sEllipse:begin
      img.Canvas.Ellipse(x0,y0,x,y);
      form1.memo1.Lines.Add(edit_canvas_name.Text+'.Ellipse('+inttostr(x0)+','+inttostr(y0)+','+inttostr(x)+','+inttostr(y)+');');
             end;
    sPoly:begin
      img.Canvas.MoveTo(x0,y0);
      img.Canvas.LineTo(x,y);
      form1.memo1.Lines.Add(edit_canvas_name.Text+'.MoveTo('+inttostr(x0)+','+inttostr(y0)+');');
      form1.memo1.Lines.Add(edit_canvas_name.Text+'.LineTo('+inttostr(x)+','+inttostr(y)+');');
          end;
    end;

end;


procedure TPAINT.PaintBox1Paint(Sender: TObject);
begin
paintbox1.Canvas.CopyRect(bounds(0,0,img.Width, img.Height),buf.Canvas, bounds(0,0,img.Width, img.Height)) ;
end;

procedure TPAINT.line_colorClick(Sender: TObject);
begin
if colordialog1.Execute then
begin
  form1.memo1.Lines.Add(edit_canvas_name.text+'.Pen.Color:=rgb('+inttostr(getrvalue(colordialog1.Color))
     +','+inttostr(getgvalue(colordialog1.Color))+','+inttostr(getbvalue(colordialog1.Color))+');');
  line_color.Canvas.Brush.Color:=colordialog1.Color;
  line_color.Canvas.Rectangle(1,1,19,19);
end;
end;

procedure TPAINT.Timer1Timer(Sender: TObject);
begin
  n5click(self);
  timer1.Enabled:=false;
end;

procedure TPAINT.ud1ChangingEx(Sender: TObject; var AllowChange: Boolean;
  NewValue: Smallint; Direction: TUpDownDirection);
begin
edt1.Text:=inttostr(NewValue);
img.Canvas.Pen.Width:=NewValue;
form1.memo1.Lines.Add(edit_canvas_name.Text+'.Pen.Width:='+inttostr(NewValue)+';');

end;

procedure TPAINT.N4Click(Sender: TObject);
begin
Close;
end;

procedure TPAINT.N5Click(Sender: TObject);
begin

form1.memo1.Clear;
img.Canvas.Brush.Color:=clwhite;
img.Canvas.FillRect(bounds(0,0,img.width,img.height));

paintbox1.Canvas.Brush.Color:=clwhite;
paintbox1.Canvas.FillRect(bounds(0,0,paintbox1.width,paintbox1.height));

img.Canvas.Pen.Color:=line_color.Canvas.Pixels[10,10];

form1.memo1.Lines.Add(edit_canvas_name.text+'.Pen.Color:=rgb('+inttostr(getrvalue(line_color.Canvas.Pixels[10,10]))
     +','+inttostr(getgvalue(line_color.Canvas.Pixels[10,10]))+','+inttostr(getbvalue(line_color.Canvas.Pixels[10,10]))+');');

img.Canvas.Brush.Color:=fill_color.Canvas.Pixels[10,10];

form1.memo1.Lines.Add(edit_canvas_name.text+'.Brush.Color:=rgb('+inttostr(getrvalue(fill_color.Canvas.Pixels[10,10]))
     +','+inttostr(getgvalue(fill_color.Canvas.Pixels[10,10]))+','+inttostr(getbvalue(fill_color.Canvas.Pixels[10,10]))+');');

form1.memo1.Lines.Add(edit_canvas_name.text+'.Pen.Style:='+cbb1.Items[cbb1.itemindex]+';');

form1.memo1.Lines.Add(edit_canvas_name.text+'.Brush.Style:='+cbb2.Items[cbb2.itemindex]+';');

form1.memo1.Lines.Add(edit_canvas_name.Text+'.Pen.Width:='+inttostr(ud1.Position)+';');



end;

end.

